# Noarch packages don't generate any debuginfo
%global debug_package %{nil}

Summary: Use the Amazon Simple Storage Service (S3)
Name: perl-Net-Amazon-S3
Version: 0.59
Release: 1%{?dist}
License: GPL+ or Artistic
Group: Development/Libraries
URL: http://search.cpan.org/dist/Net-Amazon-S3/
Source0: http://search.cpan.org/CPAN/authors/id/P/PF/PFIG/Net-Amazon-S3-%{version}.tar.gz
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

BuildArch: noarch
# Module Build
BuildRequires: perl
BuildRequires: perl(ExtUtils::MakeMaker) >= 6.30
# Module Runtime
BuildRequires: perl(Carp)
BuildRequires: perl(Data::Stream::Bulk::Callback)
BuildRequires: perl(DateTime::Format::HTTP)
BuildRequires: perl(Digest::HMAC_SHA1)
BuildRequires: perl(Digest::MD5)
BuildRequires: perl(Digest::MD5::File)
BuildRequires: perl(File::stat)
BuildRequires: perl(HTTP::Date)
BuildRequires: perl(HTTP::Status)
BuildRequires: perl(IO::File) >= 1.14
BuildRequires: perl(LWP::UserAgent::Determined)
BuildRequires: perl(MIME::Base64)
BuildRequires: perl(Moose) >= 0.85
BuildRequires: perl(Moose::Util::TypeConstraints)
BuildRequires: perl(MooseX::StrictConstructor) >= 0.16
BuildRequires: perl(MooseX::Types::DateTime::MoreCoercions) >= 0.07
BuildRequires: perl(Regexp::Common)
BuildRequires: perl(URI)
BuildRequires: perl(URI::Escape)
BuildRequires: perl(URI::QueryParam)
BuildRequires: perl(XML::LibXML)
BuildRequires: perl(XML::LibXML::XPathContext)
# Requirements of s3cl (some not yet in Fedora, so we exclude the script for now)
BuildRequires: perl(File::Find::Rule)
BuildRequires: perl(Getopt::Long)
BuildRequires: perl(MIME::Types)
BuildRequires: perl(Path::Class)
BuildRequires: perl(Pod::Usage)
BuildRequires: perl(strict)
#BuildRequires: perl(Term::Encoding)
#BuildRequires: perl(Term::ProgressBar::Simple)
BuildRequires: perl(warnings)
# Test Suite
BuildRequires: perl(File::Find)
BuildRequires: perl(File::Temp)
BuildRequires: perl(LWP::Simple)
BuildRequires: perl(Test::Exception)
BuildRequires: perl(Test::More)
BuildRequires: perl(vars)
# Release Tests
# CHANGES file should be called Changes before t/release-cpan-changes.t can work
#BuildRequires: perl(Test::CPAN::Changes)
BuildRequires: perl(Test::CPAN::Meta)
BuildRequires: perl(Test::CPAN::Meta::JSON)
BuildRequires: perl(Test::DistManifest)
BuildRequires: perl(Test::MinimumVersion)
BuildRequires: perl(Test::Mojibake)
BuildRequires: perl(Test::NoTabs)
BuildRequires: perl(Test::Pod) >= 1.41
BuildRequires: perl(Test::Portability::Files)
BuildRequires: perl(Test::Synopsis)
BuildRequires: perl(Test::Vars)
BuildRequires: perl(Test::Version)
# Runtime
Requires: perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))


%description
This module provides a Perlish interface to Amazon S3. From the
developer blurb: "Amazon S3 is storage for the Internet. It is designed
to make web-scale computing easier for developers. Amazon S3 provides a
simple web services interface that can be used to store and retrieve any
amount of data, at any time, from anywhere on the web. It gives any
developer access to the same highly scalable, reliable, fast,
inexpensive data storage infrastructure that Amazon uses to run its own
global network of web sites. The service aims to maximize benefits of
scale and to pass those benefits on to developers".

To find out more about S3, please visit: http://s3.amazonaws.com/


%prep
%setup -q -n Net-Amazon-S3-%{version}

# Get rid of unnecessary exec bits
find lib -name '*.pm' -exec chmod -c -x {} ';'


%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}


%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
%{_fixperms} %{buildroot}


%check
make test RELEASE_TESTING=1


%clean
rm -rf %{buildroot}


%files
%doc CHANGES LICENSE README
%exclude %{_bindir}/s3cl
%dir %{perl_vendorlib}/Net
%dir %{perl_vendorlib}/Net/Amazon
%dir %{perl_vendorlib}/Net/Amazon/S3
%dir %{perl_vendorlib}/Net/Amazon/S3/Client
%dir %{perl_vendorlib}/Net/Amazon/S3/Request
%{perl_vendorlib}/Net/Amazon/S3.pm
%{perl_vendorlib}/Net/Amazon/S3/Bucket.pm
%{perl_vendorlib}/Net/Amazon/S3/Client.pm
%{perl_vendorlib}/Net/Amazon/S3/Client/Bucket.pm
%{perl_vendorlib}/Net/Amazon/S3/Client/Object.pm
%{perl_vendorlib}/Net/Amazon/S3/HTTPRequest.pm
%{perl_vendorlib}/Net/Amazon/S3/Request.pm
%{perl_vendorlib}/Net/Amazon/S3/Request/CompleteMultipartUpload.pm
%{perl_vendorlib}/Net/Amazon/S3/Request/CreateBucket.pm
%{perl_vendorlib}/Net/Amazon/S3/Request/DeleteBucket.pm
%{perl_vendorlib}/Net/Amazon/S3/Request/DeleteMultiObject.pm
%{perl_vendorlib}/Net/Amazon/S3/Request/DeleteObject.pm
%{perl_vendorlib}/Net/Amazon/S3/Request/GetBucketAccessControl.pm
%{perl_vendorlib}/Net/Amazon/S3/Request/GetBucketLocationConstraint.pm
%{perl_vendorlib}/Net/Amazon/S3/Request/GetObject.pm
%{perl_vendorlib}/Net/Amazon/S3/Request/GetObjectAccessControl.pm
%{perl_vendorlib}/Net/Amazon/S3/Request/InitiateMultipartUpload.pm
%{perl_vendorlib}/Net/Amazon/S3/Request/ListAllMyBuckets.pm
%{perl_vendorlib}/Net/Amazon/S3/Request/ListBucket.pm
%{perl_vendorlib}/Net/Amazon/S3/Request/ListParts.pm
%{perl_vendorlib}/Net/Amazon/S3/Request/PutObject.pm
%{perl_vendorlib}/Net/Amazon/S3/Request/PutPart.pm
%{perl_vendorlib}/Net/Amazon/S3/Request/SetBucketAccessControl.pm
%{perl_vendorlib}/Net/Amazon/S3/Request/SetObjectAccessControl.pm
%exclude %{_mandir}/man1/s3cl.1*
%{_mandir}/man3/Net::Amazon::S3.3pm*
%{_mandir}/man3/Net::Amazon::S3::Bucket.3pm*
%{_mandir}/man3/Net::Amazon::S3::Client.3pm*
%{_mandir}/man3/Net::Amazon::S3::Client::Bucket.3pm*
%{_mandir}/man3/Net::Amazon::S3::Client::Object.3pm*
%{_mandir}/man3/Net::Amazon::S3::HTTPRequest.3pm*
%{_mandir}/man3/Net::Amazon::S3::Request.3pm*
%{_mandir}/man3/Net::Amazon::S3::Request::CompleteMultipartUpload.3pm*
%{_mandir}/man3/Net::Amazon::S3::Request::CreateBucket.3pm*
%{_mandir}/man3/Net::Amazon::S3::Request::DeleteBucket.3pm*
%{_mandir}/man3/Net::Amazon::S3::Request::DeleteMultiObject.3pm*
%{_mandir}/man3/Net::Amazon::S3::Request::DeleteObject.3pm*
%{_mandir}/man3/Net::Amazon::S3::Request::GetBucketAccessControl.3pm*
%{_mandir}/man3/Net::Amazon::S3::Request::GetBucketLocationConstraint.3pm*
%{_mandir}/man3/Net::Amazon::S3::Request::GetObject.3pm*
%{_mandir}/man3/Net::Amazon::S3::Request::GetObjectAccessControl.3pm*
%{_mandir}/man3/Net::Amazon::S3::Request::InitiateMultipartUpload.3pm*
%{_mandir}/man3/Net::Amazon::S3::Request::ListAllMyBuckets.3pm*
%{_mandir}/man3/Net::Amazon::S3::Request::ListBucket.3pm*
%{_mandir}/man3/Net::Amazon::S3::Request::ListParts.3pm*
%{_mandir}/man3/Net::Amazon::S3::Request::PutObject.3pm*
%{_mandir}/man3/Net::Amazon::S3::Request::PutPart.3pm*
%{_mandir}/man3/Net::Amazon::S3::Request::SetBucketAccessControl.3pm*
%{_mandir}/man3/Net::Amazon::S3::Request::SetObjectAccessControl.3pm*


%changelog
* Sat Aug 10 2013 Paul Howarth <paul@city-fan.org> - 0.59-1
- Update to 0.59
- This release by PFIG -> update source URL
- Package upstream's LICENSE file
- Update dependencies as per upstream
- Exclude s3cl script for now as we can't satisfy its dependencies
- Drop %%defattr, redundant since rpm 4.4
- Use %%{_fixperms} macro rather than our own chmod incantation
- Allow for a future in which we might ship manpages compressed with something
  other than gzip

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.53-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.53-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Fri Jul 20 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.53-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Mon Jul 02 2012 Petr Pisar <ppisar@redhat.com> - 0.53-4
- Perl 5.16 rebuild

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.53-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Jul 19 2011 Petr Sabata <contyk@redhat.com> - 0.53-2
- Perl mass rebuild

* Mon May 23 2011 Robert Rati <rrati@redhat> - 0.53-1
- Update to upstream 0.53

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.43-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Dec 08 2010 Lubomir Rintel <lkundrak@v3.sk> - 0.43-7
- We install into vendorlib, need proper perl version require

* Tue May 04 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.43-6
- Mass rebuild with perl-5.12.0

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.43-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.43-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Mar 24 2008  Robert Rati <rrati@redhat> - 0.43-3
- Fixed missing dependency on Class::Accessor perl module

* Thu Mar  6 2008  Robert Rati <rrati@redhat> - 0.43-2
- Package now owns all files/directories from Net on down
  to conform to packaging standards

* Thu Mar  6 2008  Robert Rati <rrati@redhat> - 0.43-1
- Initial release
